# OASYS1-LNLS-ShadowOui
Widgets developed by the Brazilian Synchrotron Light Laboratory (LNLS) - Optics Group - with useful functions for OASYS1 

## Installation

![install](https://github.com/oasys-lnls-kit/OASYS1-LNLS-ShadowOui/blob/master/images/install.png "INSTALL")

This package can be installed as an add-on. At the OASYS start-up page, click "Add-ons" (at bottom right), then click "Add more..." and insert our package name: OASYS1-LNLS-ShadowOui. It will then appear as LNLSShadowOui at the Add-ons list. Check its box on the left and click OK. Restart OASYS and then the LNLS-ShadowOui widgets will appear.

## Widgets

By this time, 3 widgets are available. Please see the [documentation](documentation) folder to learn more about them:

1. [Flux Widget](documentation/Flux-Widget) calculates flux and power in physical units after the beamline (for bending magnets, wigglers and linear undulators). It is also compatible with the geometrical source with uniform energy distribution (recommended).

2. [Beam Analysis Widget](documentation/Beam-Analysis-Widget) is similar to plotXY, but with some built-in functionalities, such as slicing, fitting, statistical calculations, label customization and more.

3. [Caustic Widget](documentation/Caustic-Widget) displays the beam propagation in a "caustic" fashion, in both 2D and 3D visualization with interactive slicing. It also calculates the beam RMS and FWHM minimum, like FocNew widget.

### Examples 

See the [Examples Folder](examples) for a few examples and usage tips of the Flux Widget.

## Authors

- Artur Clarindo Pinto (artur.pinto@lnls.br)
- Sergio Augusto Lordano Luiz (sergio.lordano@lnls.br)
- Bernd Christian Meyer (bernd.meyer@lnls.br)

## License

This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details

## Acknowledgements

The LNLS Optics Group is very grateful to Luca Rebuffi and Manuel Sanchez del Rio, for their developments in optical simulation and colaboration on this project. 
